      subroutine comvar
      implicit double precision (a-h,o-z)
      common /iofile/ior1,ior2,ior3,ior4,ior5,
     &               iow1,iow2,iow3,iow4,iow5,
     &               iow6,iow7,iow8,iow9,iow10
      common /etc/del(3),delta(3,3),p(3,3,3),dpai
c
c ----- define del(3) and Kronecker delta(3,3) (common variables)
      del(1:3) = 1.0d0
c
      do i=1,3
       do j=1,3
        if(i.eq.j) then
         delta(i,j) = 1.0d0
        else if(i.ne.j) then
         delta(i,j) = 0.0d0
        end if
       end do
      end do
c
c ----- define permutation p(i,j,k) (common variables)
      p(1:3,1:3,1:3) = 0.0d0
c
      p(1,2,3) =  1.0d0
      p(3,1,2) =  1.0d0
      p(2,3,1) =  1.0d0
      p(3,2,1) = -1.0d0
      p(1,3,2) = -1.0d0
      p(2,1,3) = -1.0d0
c
c ----- define dpai=3.14159265... (common variables)
      dpai = 4.0d0*datan(1.0d0)
c
      return
      end subroutine comvar
