      subroutine tinvdd(n,a,dt,e,nn,iw,inder)
c
      implicit real*8 (a-h,o-z)
c
      real*8 a,dt,e,aa,az,work,eps,piv
      dimension a(nn,n),iw(1)
c
c  ----- inversion of a(nxn) sweep out, complete positioning
      inder=0
      if(n-1)    910,930,101
  101 if(n.gt.nn)    go to  900
      eps=0.0d0
      dt=1.0d0
      do  100     k=1,n
      piv=0.0d0
      do  110       i=k,n
      do  110       j=k,n
      if(dabs(a(i,j)).le.dabs(piv))  go to  110
      ipiv=i
      jpiv=j
      piv=a(i,j)
  110 continue
      dt=dt*piv
      if(dabs(piv).le.eps)   go to  920
      if(k.eq.1)   eps=dabs(piv)*e
      if(ipiv.eq.k)      go to 130
      dt=-dt
      do 120   j=1,n
      work=a(ipiv,j)
      a(ipiv,j)=a(k,j)
  120 a(k,j)=work
  130 if(jpiv.eq.k)      go to  150
      dt=-dt
      do 140   i=1,n
      work=a(i,jpiv)
      a(i,jpiv)=a(i,k)
  140 a(i,k)=work
  150 iw(2*k-1)=ipiv
      iw(2*k)=jpiv
      aa=1.0d0/piv
      do 210   j=1,n
  210 a(k,j)=a(k,j)*aa
      do 220  i=1,n
      if(i.eq.k)    go to  220
      az=a(i,k)
      if(az.eq.0.0d0)    go to  220
      do 230   j=1,n
  230 a(i,j)=a(i,j)-a(k,j)*az
      a(i,k)=-aa*az
  220 continue
  100 a(k,k)=aa
      do  400 kk=2,n
      k=n+1-kk
      ij=iw(2*k)
      if(ij.eq.k)   go to  420
      do 410   j=1,n
      work=a(ij,j)
      a(ij,j)=a(k,j)
  410 a(k,j)=work
  420 ij=iw(2*k-1)
      if(ij.eq.k)   go to  400
      do 430   i=1,n
      work=a(i,ij)
      a(i,ij)=a(i,k)
  430 a(i,k)=work
  400 continue
      return
  910 inder=-1
      write(*,691)  n
  691 format(1h0,8h *** n = ,i5,5x,30hn should be positive in tinvdd)
      return
  900 inder=-1
      write(*,690)    n,nn
  690 format(1h0,8h *** n =  ,i5,5x,4hnn =,i5/
     & 55h    n should be less than or equal to nn in tinvdd       )
      return
  920 dt=0.0d0
      inder=n-k+1
      nnn=k-1
      write(*,692)  nnn
  692 format(1h0,48h*** given matrix a to tinvdd is ill conditioned
     &,24hor singular with rank = ,i4,27h.   return with no further
     &,11hcalculation       )
      return
  930 dt=a(1,1)
      k=1
      if(dt.eq.0.0d0)   go to  920
      a(1,1)=1.0d0/a(1,1)
c
      return
      end
